local frame = CreateFrame("Frame", "WoWTokenBarFrame", UIParent) 
frame:SetPoint("CENTER") 
frame:SetMovable(true)
frame:EnableMouse(true)
frame:RegisterForDrag("LeftButton")
frame:SetScript("OnDragStart", frame.StartMoving)
frame:SetScript("OnDragStop", frame.StopMovingOrSizing)

local texture = frame:CreateTexture() 
texture:SetAllPoints() 
texture:SetTexture(0,0,0,0.2) 
frame.background = texture

local text = frame:CreateFontString(nil, "ARTWORK")
text:SetFont("Fonts\\FRIZQT__.TTF", 15)
text:SetTextColor(1, 1, 1)
text:SetPoint("CENTER")

local ticker
local oldprice = 0
local state
local color = ""

function frame:OnLoad()
   frame:SetScript("OnEvent", frame.EventHandler)
   frame:RegisterEvent("TOKEN_MARKET_PRICE_UPDATED")
   frame:RegisterEvent("PLAYER_LOGIN")
end

function frame:UpdatePrice()
   local currentprice =  C_WowTokenPublic.GetCurrentMarketPrice()
   if currentprice == nil then
      currentprice = 0;
   end
   local diff = floor((currentprice - oldprice)/10000)
   
   if (oldprice ~= 0) then    
      if (currentprice > oldprice) then
         color = " (|cFFFF0000+" .. diff .. "|r)"
      elseif (currentprice < oldprice) then
         color = " (|cFF00FF00" .. diff .. "|r)"
      end
   end
   
   text:SetText("|TInterface\\Icons\\WoW_Token01:0:0:0:1|t  " .. GetMoneyString(currentprice) .. color)
   frame:SetSize(text:GetSize())
   oldprice = currentprice
end

function frame:EventHandler(event,...)
   if (event == "PLAYER_LOGIN") then
      C_WowTokenPublic.UpdateMarketPrice();
      ticker = C_Timer.NewTicker(60, function () C_WowTokenPublic.UpdateMarketPrice() end)
   end

   frame:UpdatePrice()
end

frame:OnLoad()
